﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace VisualGitSafe
{
    public class Configuration
    {
        public string YourName;
        public string ProgramRootFolder;
        public string SharedFolder;
        public bool MakeEditedFilesReadOnly;
        public string Extensions;
        public static string DefaultExtensions
        {
            get
            {
                return ".cs,.csproj,.sln,.php,.htm,.html,.js,.png,.jpg,.jpeg,.gif,.bmp,.css,.ts,.asp,.aspx,.c,.cpp,.h,.def,.dlg,.resx,.vb,.asmx,.bat,.sh,.ico,.ini,.java,.src,.zip";
            }
        }
        public bool IsDirty;
        public string[] Serialize()
        {
            string[] data = new string[5];
            data[0] = $"Your Name:{YourName}";
            data[1] = $"Program Root Folder:{ProgramRootFolder}";
            data[2] = $"Shared Folder:{SharedFolder}";
            data[3] = $"Make Edited Files Read Only:{(MakeEditedFilesReadOnly ? "1" : "0")} ";
            data[4] = $"Extensions:{Extensions}";
            return data;
        }

        /// <summary>
        /// Look for a string starting with a tag.
        /// </summary>
        /// <param name="line"></param>
        /// <param name="output"></param>
        /// <param name="startsWith"></param>
        /// <returns>Returns true if line starts with startsWith</returns>
        private static bool FindMatchingLine(string line,ref string output,string startsWith)
        {
            bool found = line.StartsWith(startsWith);
            if (found)
            {
                output = line.Substring(startsWith.Length);
            }
            return found;
        }
        public void Deserialize(string[] data)
        {
            YourName = String.Empty;
            ProgramRootFolder = String.Empty;
            SharedFolder = String.Empty;
            MakeEditedFilesReadOnly = false;
            if ((data != null) && (data.Length > 0))
            {
                foreach(string line in data)
                {
                    if (FindMatchingLine(line, ref YourName, "Your Name:"))
                    {
                        continue;
                    }
                    if (FindMatchingLine(line, ref ProgramRootFolder, "Program Root Folder:"))
                    {
                        continue;
                    }
                    if (FindMatchingLine(line, ref SharedFolder, "Shared Folder:"))
                    {
                        continue;
                    }
                    if (line.StartsWith("Make Edited Files Read Only:"))
                    {
                        MakeEditedFilesReadOnly = (line.Length > 28 ? (line.Substring(28,1)=="1") : false);
                        continue;
                    }
                    if (FindMatchingLine(line, ref Extensions, "Extensions:"))
                    {
                        continue;
                    }
                }
            }
        }
    }
}
