﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;

namespace VisualGitSafe
{
    public class RunProgram
    {
        public List<string> Output;
        public RunProgram(string program, string parameters, string startFolder)
        {
            string line;
            Output = null;
            Process process = new Process();
            ProcessStartInfo startInfo = new ProcessStartInfo();
            startInfo.FileName = program;
            startInfo.Arguments = parameters;
            startInfo.WorkingDirectory = startFolder;
            startInfo.UseShellExecute = false;
            startInfo.RedirectStandardOutput = true;
            startInfo.WindowStyle = ProcessWindowStyle.Hidden;
            startInfo.CreateNoWindow = true;
            process.StartInfo = startInfo;            
            process.Start();
            process.WaitForExit();
            Output = new List<string>();
            while (true)
            {
                line = process.StandardOutput.ReadLine();
                if (line == null)
                {
                    break;
                }
                Output.Add(line);
            }
            return;
        }
    }
}
